// Author: Hezhk3

// see https://www.shadertoy.com/view/Xs3cDn

varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

uniform highp float iTime;
uniform highp vec2 iResolution;

void main()
{
    highp float M_PI = 3.14159265358979323846264338327950288;
    
    highp float t = fract(iTime);
    highp float s = sin((t - 0.5) * M_PI);
    highp float g = s * 2.2;
    
    highp vec2 uv = textureCoordinate;
    highp vec2 p = uv * 2.0 - 1.0;
    highp float as = iResolution.y / iResolution.x;
    
    highp vec3 col1 = texture2D(inputImageTexture, uv).rgb;
    highp vec3 col2 = texture2D(inputImageTexture2, uv).rgb;
    
    highp float a = clamp(cos(p.x * 200.0) - cos(p.y * 200.0 * as) + g + 1.0, 0.0, 1.0);
    a = pow(a, 10.0);
    highp vec3 col = mix(col1, col2, a);
    
    gl_FragColor = vec4(col, 1.0);
}
