precision highp float;

varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform float progress;
uniform float ratio;
const float start = 0.0;
const float duration = 1.0;

float rand(float n){
    return fract(sin(mod(dot(n, 12.9898),3.14))*43758.5453);
}

void main()
{
    vec2 uv = textureCoordinate;
    vec3 col1 = texture2D(inputImageTexture, uv).rgb;
    vec3 col2 = texture2D(inputImageTexture2, uv).rgb;

    float iTime = progress * duration;
    float interval = 1.0 / 20.0;
    float jointTime = 0.5 * duration;
    vec3 col = step(iTime, jointTime) * col1 + (1.0 - step(iTime, jointTime)) * col2;

    if (iTime < jointTime - 4.0* interval &&
    (0.05 + 0.1 * progress / 0.5) > rand(iTime + start)) {
        col = col2;
    }

    if (iTime > jointTime + 1.0 * interval && iTime < jointTime + 2.0 *interval) {
        col = col1;
    }
    if (iTime > jointTime - 1.0* interval && iTime < jointTime - 0.0* interval) {
        col = col2;
    }
    if (iTime > jointTime - 3.0* interval && iTime < jointTime - 2.0* interval) {
        col = col2;
    }


    gl_FragColor = vec4(col, 1.0);
}