precision highp float;

varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform float progress;
uniform float ratio;
uniform highp vec2 iResolution;
const float start = 0.0;
const float duration = 1.0;


float rand(float f){
    return fract(sin(mod(dot(f, 12.9898),3.14))*43758.5453);
}

float randn(float f, float n) {
    return ceil(rand(f) * n);
}

vec3 mainCol(vec2 uv) {
    vec3 col = texture2D(inputImageTexture,uv).rgb;
    if (progress > 0.5) {
        col = texture2D(inputImageTexture2,uv).rgb;
    }
    return col;
}

void main()
{
    float iTime = progress * duration + start;
    float jointTime = 0.5 * duration + start;
    vec2 uv = textureCoordinate;
    float interval = 1.0 / 20.0;

    float hight = min(iResolution.x, iResolution.y)/20.0;

    float block = floor(uv.y * iResolution.y / hight);


    vec3 col = mainCol(uv);
    float end = 0.6;
    float threshold = 0.7;
    if (iTime < jointTime + duration / 2.0 &&
    iTime > jointTime - 4.0 * interval) {
        threshold = -1.0;
    }

    if (progress > 0.0 && progress < end && rand(floor(iTime/0.07))> threshold) {
        float rate = 2.0 * progress;
        if (progress > 0.5) {
            rate = 2.0 *(end - progress) / (end - 0.5);
        }
        uv.x += (rand(block * 4.65 * iTime) - 0.5) * 220.0 * sin(3.14159 * iTime * 0.5/0.3) / iResolution.x + (rand(floor(uv.y * iResolution.y / 2.0) * iResolution.y * 4.79 * iTime) - 0.5) *  (80.0 + 80.0 * rate) / iResolution.x;
        uv.x = fract(uv.x + 1.0);
        col = mainCol(uv);
    }

    gl_FragColor = vec4(col, 1.0);
}