precision highp float;

varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform float progress;
uniform float ratio;
const float start = 0.0;
const float duration = 1.0;
uniform highp vec2 iResolution;


float rand(float f){
    return fract(sin(mod(dot(f, 12.9898),3.14))*43758.5453);
}

float randn(float f, float n) {
    return ceil(rand(f) * n);
}

float calcBlock(float x, float pixel, float ractor) {
    float p = 0.0;
    for (float i = 1.0; ;i++) {
        p += randn(ractor * i, 5.0) * pixel;
        if (p > x){
            return i;
        }
    }
    return p;
}

void main()
{
    float iTime = progress * duration + start;
    vec2 uv = textureCoordinate;

    float hight = 65.0;
    float typeRate = 1.0;
    float r1 = 0.45;
    float r2 = 0.35;
    float r3 = 0.1;
    float threshold = 0.5;

    float interval = 1.0 / 30.0;
    float jointTime = 0.5 * duration + start;
    if (iTime > jointTime - 4.0 * interval && iTime < jointTime + 2.0 *interval) {
        typeRate = r1 + r2;
        hight = 80.0;
        threshold = -1.0;
    } else if (iTime > jointTime + 2.0 *interval) {
        threshold  = 0.7;
    } else if (iTime < jointTime - 0.5) {
        threshold  = 0.7;
    }

    float block = calcBlock(textureCoordinate.y * iResolution.y, hight, iTime);
    float line_thresh = pow(rand(iTime * 3.345 * block), 3.0);

    vec3 col = (progress < 0.5 ? texture2D(inputImageTexture, uv) : texture2D(inputImageTexture2, uv)).rgb;

    vec4 left = progress < 0.5 ? texture2D(inputImageTexture, uv) : texture2D(inputImageTexture2, uv);
    float xOff = step(rand(iTime*4.21), 0.10) * 0.01;
    vec4 right = progress < 0.5 ? texture2D(inputImageTexture, uv + vec2(xOff, 0.0)) : texture2D(inputImageTexture2, uv + vec2(xOff, 0.0));

    col = vec3(left.r, right.gb);

    if (line_thresh > threshold) {
        float n1 = rand(iTime * block * 3.41);
        float n2 = rand(iTime * block * 1.23);

        float nRate = step(rand(iTime * block * 2.36), 0.7);
        n1 = mix(n1, 0.0, nRate);
        n2 = mix(n2, 1.0, nRate);
        if (iTime > jointTime - 4.0 * interval && iTime < jointTime + 2.0 *interval) {
            n1 = 0.0;
            n2 = 1.0;
        }

        if ((n1 > n2 && n1 > uv.x && uv.x > n2) ||
        (n1 < n2 && n1 < uv.x && uv.x < n2)){

            if (iTime > jointTime - 4.0 * interval && iTime < jointTime + 2.0 *interval) {
                float sg = (step(rand(iTime * block * 2.36), 0.5) - 0.5) * 2.0;
                uv.x += sg * rand(iTime * block * 5.75) * 0.2 + 0.3;
            } else {
                uv.x += (rand(iTime * block * 5.75) - 0.5) * 0.5;
            }
            uv.x = fract(uv.x + 1.0);

            float type = rand(iTime * block * 4.29) * typeRate;

            if (type < r1) {
            } else if (type < r1 + r2) {
                xOff += 0.1 * rand(iTime * block * 4.32) - 0.05;
                right = progress < 0.5 ? texture2D(inputImageTexture, uv + vec2(xOff, 0.0))
                        : texture2D(inputImageTexture2, uv + vec2(xOff, 0.0));
                col = vec3(left.r, right.gb);
            } else if (type < r1 + r2 + r3) {
                col = mix(col, vec3(0.0), 0.2);
            } else {
                col = mix(col, vec3(1.0), 0.2);
            }
        }
    }

    gl_FragColor = vec4(col, 1.0);
}