precision highp float;

varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform float progress;
uniform float ratio;
const float start = 0.0;
const float duration = 1.0;
uniform int type;


float mixTime = min(0.1, duration);

vec3 mainCol(vec2 uv) {
    vec3 col = texture2D(inputImageTexture,uv).rgb;
    if (progress > 0.5 - mixTime/2.0/duration && progress < 0.5 + mixTime/2.0/duration){
        col = mix(texture2D(inputImageTexture,uv).rgb, texture2D(inputImageTexture2,uv).rgb, duration*(progress-0.5 + mixTime/2.0/duration)/mixTime);
    } else if (progress > 0.5) {
        col = texture2D(inputImageTexture2,uv).rgb;
    }
    return col;
}

void main()
{
    float iTime = progress * duration + start;
    float jointTime = 0.5 * duration + start;
    vec2 uv = textureCoordinate;

    float interval = 1.0 / 30.0;
    float anTime = duration;
    vec3 col = mainCol(uv);

    float time = iTime;

    if (time > jointTime - anTime/2.0 && time < jointTime + anTime/2.0) {
        if (type == 0) {
            if (uv.x < (time - jointTime + anTime/2.0)/(anTime/2.0) && time < jointTime){
                uv.x = (time - jointTime + anTime/2.0)/(anTime/2.0);
            }
            if (uv.x > (time - jointTime )/(anTime/2.0) && time >= jointTime){
                uv.x = (time - jointTime )/(anTime/2.0) ;
            }
        } else if (type == 1) {
            time = 1.0 - time;
            if (uv.y < (time - jointTime + anTime/2.0)/(anTime/2.0) && time < jointTime){
                uv.y = (time - jointTime + anTime/2.0)/(anTime/2.0);
            }
            if (uv.y > (time - jointTime )/(anTime/2.0) && time >= jointTime){
                uv.y = (time - jointTime )/(anTime/2.0) ;
            }
        }

        col = mainCol(uv);
    }

    gl_FragColor = vec4(col, 1.0);
}