precision highp float;

varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform float progress;
uniform float ratio;
const float start = 0.0;
const float duration = 1.0;


float mixTime = min(0.5, duration);

vec3 mainCol(vec2 uv) {
    vec3 col = texture2D(inputImageTexture,uv).rgb;
    if (progress > 0.5 - mixTime/2.0/duration && progress < 0.5 + mixTime/2.0/duration) {
        col = mix(texture2D(inputImageTexture,uv).rgb, texture2D(inputImageTexture2,uv).rgb, duration*(progress-0.5 + mixTime/2.0/duration)/mixTime);
    } else if (progress > 0.5) {
        col = texture2D(inputImageTexture2,uv).rgb;
    }
    return col;
}


void main()
{
    float iTime = progress * duration + start;
    float jointTime = 0.5 * duration + start;
    vec2 uv = textureCoordinate;


    float interval = 1.0 / 30.0;
    float anTime = duration;
    vec3 col = mainCol(uv);

    float time = iTime;

    float off = 0.075;
    float wave = 0.125;
    float rate = 1.0;
    if (progress < 0.5) {
        rate = 2.0 * progress;
    } else {
        rate = 2.0 * (1.0 - progress);
    }

    if (time > jointTime - anTime/2.0 && time < jointTime + anTime/2.0) {
        uv.y += sin(uv.x * 3.14 * 2.0 + iTime * 5.0) * wave * rate;
        col = mainCol(uv);
        col.r = mainCol(uv + vec2(0.0, off * rate)).r;
    }

    gl_FragColor = vec4(col, 1.0);
}